class StudentProgress::Cohort < Sequel::Model
  one_to_many :students
  one_to_many :progress_reports
  def add_students(usernames)
    usernames.each do |username|
      student = StudentProgress::Student.find_or_create(github_username: username.downcase)
      self.add_student(student)
      student.save
    end
    self.save
  end

  def remove_students(usernames)
    removed = 0
    usernames.each do |username|
      student = self.students_dataset.first(github_username: username.downcase)
      if student
        self.remove_student(student)
        removed += 1
      else
        puts "Student with github username: #{username} not found."
      end
    end
    self.save
    removed
  end

  def delete_and_unassign_students
    students.each do |student|
      student.cohort_id = nil
      student.save
    end
    self.delete
  end

  def run_progress_report
    StudentProgress::Scraper.scrape_progress(self)
  end
end