class StudentProgress::ProgressReport < Sequel::Model
  one_to_many :student_reports
  many_to_one :cohort

  def on_track(labs_goal, cohort=nil)
    result = {}
    result[:on_track] = student_reports.select do |report| 
      labs_goal[:labs] - report.labs_complete <= 5 && (cohort.nil? || report.student.cohort == cohort)
    end
    result[:behind] = student_reports.select do |report| 
      labs_goal[:labs] - report.labs_complete > 5 && (cohort.nil? || report.student.cohort == cohort)
    end
    result[:ahead] = student_reports.select do |report| 
      labs_goal[:labs] - report.labs_complete <= -5 && (cohort.nil? || report.student.cohort == cohort)
    end
    result
  end

  def import_progress_from_periscope
    if self.cohort.periscope_url 
      StudentProgress::ProgressImporter.import(self.cohort.periscope_url)
    end
  end
end