class StudentProgress::Student < Sequel::Model
  many_to_one :cohort
  one_to_many :student_reports
  one_to_many :completed_lessons
                
  def current_lab
    student_reports.last.current_lab
  end

  def full_name
    "#{first_name} #{last_name}"
  end

  def distance_to_goal(goal)
    current_index = StudentProgress::Lesson.all.index { |l| l.title == current_lab }
    goal_index = StudentProgress::Lesson.all.index { |l| l.title == goal }
    distance = {
      "Readme" => 0,
      "Lab" => 0,
      "Project" => 0
    }
    StudentProgress::Lesson.all[current_index..goal_index].each do |l|
      distance[l.content_type] += 1
    end
    distance
  end
end