class StudentProgress::StudentReport < Sequel::Model 
  many_to_one :progress_report
  many_to_one :student

  def student_name
    self.student && self.student.full_name
  end

  def generate_current_topic_status
    topic = StudentProgress::Lesson.topic_from_lesson_title(student.current_lab)
    ratio = (topic.lessons.map(&:id) & student.completed_lessons.map(&:lesson_id)).length/topic.lessons.count.to_f
    percent = (ratio*100).round(2)
    status = student.cohort.periscope_url ? "#{topic.title}: #{percent}% complete" : "to track this, add perisocpe url to cohort"
    self.current_topic_status = status
    self.save
    status
  end
end 